Welcome to Subscribe On Youtube
Formatted question description: https://leetcode.ca/all/2375.html
2375. Construct Smallest Number From DI String
- Difficulty: Medium.
- Related Topics: String, Backtracking, Stack, Greedy.
- Similar Questions: DI String Match.
Problem
You are given a 0-indexed string pattern
of length n
consisting of the characters 'I'
meaning increasing and 'D'
meaning decreasing.
A 0-indexed string num
of length n + 1
is created using the following conditions:
-
num
consists of the digits'1'
to'9'
, where each digit is used at most once. -
If
pattern[i] == 'I'
, thennum[i] < num[i + 1]
. -
If
pattern[i] == 'D'
, thennum[i] > num[i + 1]
.
Return the lexicographically **smallest possible string num
that meets the conditions.**
Example 1:
Input: pattern = "IIIDIDDD"
Output: "123549876"
Explanation:
At indices 0, 1, 2, and 4 we must have that num[i] < num[i+1].
At indices 3, 5, 6, and 7 we must have that num[i] > num[i+1].
Some possible values of num are "245639871", "135749862", and "123849765".
It can be proven that "123549876" is the smallest possible num that meets the conditions.
Note that "123414321" is not possible because the digit '1' is used more than once.
Example 2:
Input: pattern = "DDD"
Output: "4321"
Explanation:
Some possible values of num are "9876", "7321", and "8742".
It can be proven that "4321" is the smallest possible num that meets the conditions.
Constraints:
-
1 <= pattern.length <= 8
-
pattern
consists of only the letters'I'
and'D'
.
Solution (Java, C++, Python)
-
class Solution { public String smallestNumber(String pattern) { int[] ret = new int[pattern.length() + 1]; ret[0] = 1; int max = 2; int lastI = 0; for (int i = 0; i < pattern.length(); i++) { if (pattern.charAt(i) == 'I') { ret[i + 1] = max++; lastI = i + 1; } else { for (int j = i; j >= lastI; j--) { ret[j + 1] = ret[j]; } ret[lastI] = max++; } } StringBuilder sb = new StringBuilder(); for (int i : ret) { sb.append(i); } return sb.toString(); } } ############ class Solution { private boolean[] vis = new boolean[10]; private StringBuilder t = new StringBuilder(); private String p; private String ans; public String smallestNumber(String pattern) { p = pattern; dfs(0); return ans; } private void dfs(int u) { if (ans != null) { return; } if (u == p.length() + 1) { ans = t.toString(); return; } for (int i = 1; i < 10; ++i) { if (!vis[i]) { if (u > 0 && p.charAt(u - 1) == 'I' && t.charAt(u - 1) - '0' >= i) { continue; } if (u > 0 && p.charAt(u - 1) == 'D' && t.charAt(u - 1) - '0' <= i) { continue; } vis[i] = true; t.append(i); dfs(u + 1); t.deleteCharAt(t.length() - 1); vis[i] = false; } } } }
-
class Solution: def smallestNumber(self, pattern: str) -> str: def dfs(u): nonlocal ans if ans: return if u == len(pattern) + 1: ans = ''.join(t) return for i in range(1, 10): if not vis[i]: if u and pattern[u - 1] == 'I' and int(t[-1]) >= i: continue if u and pattern[u - 1] == 'D' and int(t[-1]) <= i: continue vis[i] = True t.append(str(i)) dfs(u + 1) vis[i] = False t.pop() vis = [False] * 10 t = [] ans = None dfs(0) return ans ############ # 2375. Construct Smallest Number From DI String # https://leetcode.com/problems/construct-smallest-number-from-di-string/ class Solution: def smallestNumber(self, pattern: str) -> str: n = len(pattern) used = [False] * 10 ans = "987654321" def dfs(index, s, prev): nonlocal ans if index == n: ss = "".join(s) if ss < ans: ans = ss return if pattern[index] == "I": for i in range(prev + 1, 10): if used[i]: continue used[i] = True s.append(str(i)) dfs(index + 1, s, i) used[i] = False s.pop() else: for i in range(prev - 1, 0, -1): if used[i]: continue used[i] = True s.append(str(i)) dfs(index + 1, s, i) used[i] = False s.pop() for i in range(1, 10): used[i] = True dfs(0, [str(i)], i) used[i] = False return ans
-
class Solution { public: string ans = ""; string pattern; vector<bool> vis; string t = ""; string smallestNumber(string pattern) { this->pattern = pattern; vis.assign(10, false); dfs(0); return ans; } void dfs(int u) { if (ans != "") return; if (u == pattern.size() + 1) { ans = t; return; } for (int i = 1; i < 10; ++i) { if (!vis[i]) { if (u && pattern[u - 1] == 'I' && t.back() - '0' >= i) continue; if (u && pattern[u - 1] == 'D' && t.back() - '0' <= i) continue; vis[i] = true; t += to_string(i); dfs(u + 1); t.pop_back(); vis[i] = false; } } } };
-
func smallestNumber(pattern string) string { vis := make([]bool, 10) t := []byte{} ans := "" var dfs func(u int) dfs = func(u int) { if ans != "" { return } if u == len(pattern)+1 { ans = string(t) return } for i := 1; i < 10; i++ { if !vis[i] { if u > 0 && pattern[u-1] == 'I' && int(t[len(t)-1]-'0') >= i { continue } if u > 0 && pattern[u-1] == 'D' && int(t[len(t)-1]-'0') <= i { continue } vis[i] = true t = append(t, byte('0'+i)) dfs(u + 1) vis[i] = false t = t[:len(t)-1] } } } dfs(0) return ans }
-
function smallestNumber(pattern: string): string { const n = pattern.length; const res = new Array(n + 1).fill(''); const vis = new Array(n + 1).fill(false); const dfs = (i: number, num: number) => { if (i === n) { return; } if (vis[num]) { vis[num] = false; if (pattern[i] === 'I') { dfs(i - 1, num - 1); } else { dfs(i - 1, num + 1); } return; } vis[num] = true; res[i] = num; if (pattern[i] === 'I') { for (let j = res[i] + 1; j <= n + 1; j++) { if (!vis[j]) { dfs(i + 1, j); return; } } vis[num] = false; dfs(i, num - 1); } else { for (let j = res[i] - 1; j > 0; j--) { if (!vis[j]) { dfs(i + 1, j); return; } } vis[num] = false; dfs(i, num + 1); } }; dfs(0, 1); for (let i = 1; i <= n + 1; i++) { if (!vis[i]) { res[n] = i; break; } } return res.join(''); }
Explain:
nope.
Complexity:
- Time complexity : O(n).
- Space complexity : O(n).